
  #ifndef __KUP__FREPORT__
  #define __KUP__FREPORT__

  const
    MAX_PATH = 260,
    MAX_LINE = 512;

  extern int  QuietMode;                // 娩 ०
  extern char AppDir[MAX_PATH];         // ⠫ ᪠
  extern char Address[MAX_LINE];        //  ⥬
  extern char NewFileName[MAX_LINE];    //  䠩  ᯨ᪮  䠩
  extern char ResultFileName[MAX_LINE]; //  䠩  饭 १
  extern char AreasFileName[MAX_LINE];  //  䠩 FILin- areas.ctl
  extern int  DeleteFile;               // 㤠  室 䠩
  extern int  UseShortOrigin;           // ᯮ짮 ⪨ Origin
                                        //  ᮢ ,   ॣ
  extern int  UseShortUplink;           // ᯮ짮 ⪨ Uplink
  extern int  AddEmptyLine;             //   ப  
  extern char PathTemplate[MAX_LINE];   // ⮢   䠩
  extern int  SkipDescChars;            // ய᪠ ᯥ. ᨬ  ᠭ
  extern char SkipSet[MAX_LINE];        //  ᨬ,  ய᪠
  extern int  ReplaceSoftCR;            //    H () ᪮
                                        // H ()
  extern int  CreateFileFlags;          //   䠩 䫠.
                                        // ਬ, ᫨  ᬮ 
                                        // 㤥 㦥  䠩  -
                                        // ७樨 AFTNMISC,   ⠫
                                        // 䫠 㤥 ᮧ 䫠
                                        // AFTNMISC.flag
  extern char FileFlagsDir[MAX_PATH];   //   ⠫ 䠩-䫠
  extern char HeaderFileName[MAX_PATH]; //  䠩 - 
  extern char TailFileName[MAX_PATH];   //  䠩 - 殢

  enum { ID_SUBSTRING, ID_ORIGIN, ID_UPLINK };

  struct TemplateStruct {
    char *S;
    int   ID;
  };

  extern int             TplsNumber; // ᫮ 蠡稪
  extern TemplateStruct *PathTpl;    // ᨢ ⮢祪

  struct FileStruct {
    char *Name;
    int   Size;
    char *Desc;
    char *Origin;
    char *Uplink;
  };

  struct AreaStruct {
    char           *Name;
    char           *Desc;
    FileStruct     *Files;
    int             FilesNumber;
  };

  struct FileListStruct {
    FileStruct      File;
    FileListStruct *Next;
  };

  struct AreaListStruct {
    AreaStruct      Area;
    FileListStruct *FileList, *LastFile;
    AreaListStruct *Next;
  };

  void DefaultControls();
  void ReadControls();
  void MakeReport();
  void TruncateAddress(char *addr);
  void SortFiles( FileStruct *Files, int FilesNumber );
  void SortAreas( AreaStruct *Areas, int AreasNumber );
  int  GetSubstringLen(char *S, int width);
  void FormatSize(int size, char *buf);
  void PrepareTemplates();
  void PrepareSkipTable();
  void DoSkipChars(char *S);
  void DoReplaceSoftCR(char *S);
  void SkipSpaces(char *s);
  void PrintLogo();
  int  CreateZeroFile( char *fname );

  #endif